// Parser.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "string.h"
#include "stdio.h"
#include "fstream"
#include "iostream"
#include "list"
#include "string"
#include "pugixml.hpp"
#include "ctype.h"

//using namespace System;
using namespace std;
using namespace pugi;

namespace ParserHCV
{

#pragma region structs

struct ruleSyntax
{
	int ruleNo;
	bool isThisBase;
	string neuter;
	string verb;
	string preposition;
	string constraint;
	string noun;
};

struct completeKeyword
{
string neuter;
string verb;
string preposition;
};


struct variableValue
{
string name;
long double min;
long double max;
bool isMin;
bool isMax;
};

struct constValue
{
string name;
long double value;
};

struct constraint
{
	int type;
	bool constant;//is this constant value or variable
	variableValue *v;//one of these 2
	constValue *c;
};

#pragma endregion


#pragma region agent

class agent
{
private: 
	string name;

public: 
	agent()
	{
		name="";
	}
	
	void setName(string name)
		{
			this->name=name;
		}
	string getName()
		{
			return this->name;
		}

};

#pragma endregion


#pragma region rule
class rule
{
private:
	int ruleNo;
	agent *base;
	agent *parent;
	agent *optional;
	constraint *c;
	list <agent*> rule7;
public:
	rule()
	{
		base=NULL;
	}
	void setRuleNo(int ruleNo)
	{
		this->ruleNo=ruleNo;
	}
	int getRuleNo()
	{
		return this->ruleNo;
	}
	string getRuleNoS()
	{
		string tmp; // brzydkie rozwizanie
		sprintf((char*)tmp.c_str(), "%d", this->ruleNo);
		return tmp.c_str();
	}
	void setBaseAgent(agent *baseAgent)
	{
		this->base=baseAgent;
	}
	agent* getBaseAgent()
	{
		return this->base;		
	}
	void setParentAgent(agent *parentAgent)
	{
		this->parent=parentAgent;
	}
	agent* getParentAgent()
	{
		return this->parent;
	}
	void setOptionalAgent(agent *optionalAgent)
	{
		this->optional=optionalAgent;
	}
	agent* getOptionalAgent()
	{
		return this->optional;
	}
	void setConstraint(constraint *cst)
	{
		this->c=cst;
	}
	constraint* getConstraint()
	{
		return this->c;
	}
	list <agent*> agentsForRule7()
	{
		return this->rule7;
	}
	void addAgentForRule7(agent* pointer)
	{
	this->rule7.push_back(pointer);
	}
};
#pragma endregion

#pragma region parser

class parser
{
private:
	char *file;

	list <constValue> constants;
	list <variableValue> variables;
	list <agent> agents;
	list <rule> rules;
	list <constraint> constraints;

	string errorList;
	string notificationList;

	#pragma region innerFunctions
	

	int* rulesHere(string str,int &w)
	{
		int countComma=0; //count of comma ","
		for(unsigned int i=0;i<str.size();i++)
			if(str[i]==',')
				countComma++;
		int* t= new int [6];
		int j=0;
		for(unsigned int i=0;i<str.size();i++)
			if(str[i]!=',')
				{
					t[j]=str[i]-'0';
					j++;
				}
			w=j;
			return t;
	}

	bool isThisConstOrVariable(string str) //after we know its not rule
	{
	for(unsigned int i=0;i<str.size();i++)
	{
		if(str.substr(i,3).compare(" = ")==0)
			{
				return true;
			}
		if(str.substr(i,3).compare(" < ")==0)
			{
				return true;
			}
		if(str.substr(i,3).compare(" > ")==0)
			{
				return true;
			}
	}

	return false;
	}

	void addValue(string str)//add variable or const to list.
	{
	constValue c;
	variableValue v;
	for(unsigned int i=0;i<str.size();i++)
	{
		if(str.substr(i,3).compare(" = ")==0)
			{
				
				c.name=str.substr(0,i);
				c.value = atof(str.substr(i+3).c_str());
				constants.push_back(c);
				break;
			}

		//1. xyz > 0
		//2. 32 > xyz > 0
		if(str.substr(i,3).compare(" > ")==0)
			{
				bool isThereAnyNumber=false;
				for(unsigned int j=0;j<i;j++)
				{
					if(isdigit(str[j]))
						isThereAnyNumber=true;
				}
				if(isThereAnyNumber)// 2.
				{
					for(unsigned int j=i+1;j<str.size();j++)
					{
						if(str.substr(j,3).compare(" > ")==0)
						{
							v.name=str.substr(i+3,j-i-3);
							v.isMin=true;
							v.isMax=true;
							v.min=atof(str.substr(j+3).c_str());
							v.max=atof(str.substr(0,i).c_str());
							variables.push_back(v);
							
						}
					}
					
				}
				else // 1.
				{		
					v.name=str.substr(0,i);
					v.isMin=true;
					v.isMax=false;
					v.min=atoi(str.substr(i+3).c_str());
					variables.push_back(v);
										
				}
				break;
			}
		//1. xyz < 0
		//2. 32 < xyz < 0
		if(str.substr(i,3).compare(" < ")==0)
			{
				bool isThereAnyNumber=false;
				for(unsigned int j=0;j<i;j++)
				{
					if(isdigit(str[j]))
						isThereAnyNumber=true;
				}
				if(isThereAnyNumber)// 2.
				{
					for(unsigned int j=i+1;j<str.size();j++)
					{
						if(str.substr(j,3).compare(" < ")==0)
						{
							v.name=str.substr(i+3,j-i-3);
							v.isMin=true;
							v.isMax=true;
							v.max=atof(str.substr(j+3).c_str());
							v.min=atof(str.substr(0,i).c_str());
							variables.push_back(v);
							
						}
					}
					
				}
				else // 1.
				{		
					v.name=str.substr(0,i);
					v.isMin=false;
					v.isMax=true;
					v.max=atoi(str.substr(i+3).c_str());
					variables.push_back(v);
					
				}
				break;
			}//end of <

	}

	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	ruleSyntax isThisRule2(string str)//0 if no, 2-6 || 12-16 if yes
	{
		//2 3 4 5 6
		completeKeyword rules[7];//we use indexes 2-6

		ruleSyntax result;
		
		bool checkNeuter=false;
		bool checkVerb=false;
		bool checkPreposition=false;
		int neutersCount=0, verbsCount=0, prepositionsCount=0;
		xml_document doc;
		xml_parse_result resultxml = doc.load_file("keywords.xml");
		int type=0;
		int* typeA;
		int indexA;
		//base keywords

	for (xml_node keyword = doc.child("keywords").child("keyword"); keyword; keyword = keyword.next_sibling("keyword"))
    {
	//	type=keyword.attribute("ruleType").as_int();
		typeA=rulesHere(keyword.attribute("ruleType").as_string(),indexA);

		if(typeA[0]==7)
		{
			for (xml_node noun=keyword.child("base").child("nouns").child("noun"); noun; noun = noun.next_sibling("noun"))
			{
			string nounstr=noun.child_value("value");
			for(unsigned int i=0;i<str.size();i++)
			if(str.substr(i,nounstr.size()).compare(nounstr)==0)
				{
					result.noun=nounstr;
					result.ruleNo=7;
					result.isThisBase=true;
					return result;
				}
			}//nouns
			break;
		}
		checkNeuter=false;
		checkVerb=false;
		checkPreposition=false;
		neutersCount=0; 
		verbsCount=0;
		prepositionsCount=0;
		
		for (xml_node neuter=keyword.child("base").child("verbs").child("verb"); neuter; neuter = neuter.next_sibling("verb"))
		{
		neutersCount+=1;
		string neuterstr=neuter.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,neuterstr.size()).compare(neuterstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
					if(typeA[ii]!=6)
						rules[typeA[ii]].neuter=neuterstr;
					else
						rules[typeA[ii]].verb=neuterstr;
			}
		}//neuters
		
		for (xml_node verb=keyword.child("base").child("adjectives").child("adjective"); verb; verb = verb.next_sibling("adjective"))
		{
		verbsCount+=1;
		string verbstr=verb.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,verbstr.size()).compare(verbstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
					rules[typeA[ii]].verb=verbstr;
			}
		}//verbs

		for (xml_node preposition=keyword.child("base").child("prepositions").child("preposition"); preposition; preposition = preposition.next_sibling("preposition"))
		{
		prepositionsCount+=1;
		string prepositionstr=preposition.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,prepositionstr.size()).compare(prepositionstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
					rules[typeA[ii]].preposition=prepositionstr;
			}
		}//prepositions
		
		for(int r=2;r<5;r++)
			if(rules[r].neuter.size()>0 && rules[r].verb.size()>0 && rules[r].preposition.size()>0)
			{
			result.ruleNo=r;
			result.neuter=rules[r].neuter;
			result.verb=rules[r].verb;
			result.preposition=rules[r].preposition;
			return result;		
			}
		if(rules[5].neuter.size()>0 && rules[5].verb.size()>0)
		{
			result.ruleNo=5;
			result.neuter=rules[5].neuter;
			result.verb=rules[5].verb;
			return result;		
		}
		if(rules[6].verb.size()>0 && rules[6].preposition.size()>0)
		{
			result.ruleNo=6;
			result.verb=rules[6].verb;
			result.preposition=rules[6].preposition;
			return result;		
		}

	}//base keywords

	for(int r=2;r<7;r++)
	{
	rules[r].neuter="";
	rules[r].preposition="";
	rules[r].verb="";
	}


	//alt keywords
	for (xml_node keyword = doc.child("keywords").child("keyword"); keyword; keyword = keyword.next_sibling("keyword"))
    {
		//type=keyword.attribute("ruleType").as_int();
		typeA=rulesHere(keyword.attribute("ruleType").as_string(),indexA);

		if(typeA[0]==7)
			break;
		checkNeuter=false;
		checkVerb=false;
		checkPreposition=false;
		neutersCount=0; 
		verbsCount=0;
		prepositionsCount=0;
		for (xml_node neuter=keyword.child("alt").child("neuters").child("neuter"); neuter; neuter = neuter.next_sibling("neuter"))
		{
		neutersCount+=1;
		string neuterstr=neuter.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,neuterstr.size()).compare(neuterstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
				rules[typeA[ii]].neuter=neuterstr;
			}
		}//neuters
		if(neutersCount==0)
			checkNeuter=true;//if there are no neuters in xml, do not require them in rules
		for (xml_node verb=keyword.child("alt").child("verbs").child("verb"); verb; verb = verb.next_sibling("verb"))
		{
		verbsCount+=1;
		string verbstr=verb.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,verbstr.size()).compare(verbstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
				rules[typeA[ii]].verb=verbstr;
			}
		}//verbs
		if(verbsCount==0)
			checkVerb=true;//if there are no verbs in xml, do not require them in rules
		for (xml_node preposition=keyword.child("alt").child("prepositions").child("preposition"); preposition; preposition = preposition.next_sibling("preposition"))
		{
		prepositionsCount+=1;
		string prepositionstr=preposition.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,prepositionstr.size()).compare(prepositionstr)==0)
			{
				for(int ii=0;ii<indexA;ii++)
				rules[typeA[ii]].preposition=prepositionstr;
			}
		}//prepositions

		for(int r=2;r<4;r++)
			if(rules[r].verb.size()>0)
			{
			result.ruleNo=r+10;
			result.neuter=rules[r].neuter;
			result.verb=rules[r].verb;
			result.preposition=rules[r].preposition;
			return result;		
			}
		if(rules[4].verb.size()>0 && rules[4].preposition.size()>0)
		{
			result.ruleNo=4+10;
			result.verb=rules[4].verb;
			result.preposition=rules[4].preposition;
			return result;		
		}
		if(rules[5].verb.size()>0)
		{
			result.ruleNo=5+10;
			result.verb=rules[5].verb;
			return result;		
		}


	}//alt keywords

	result.ruleNo=0;
	return result;
	}//isthisRule

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


	ruleSyntax isThisRule(string str)//0 if no, 2-6 || 12-16 if yes
	{
		ruleSyntax result;
		
		bool checkNeuter=false;
		bool checkVerb=false;
		bool checkPreposition=false;
		int neutersCount=0, verbsCount=0, prepositionsCount=0;
		xml_document doc;
		xml_parse_result resultxml = doc.load_file("keywords.xml");
		int type=0;

		//base keywords
	for (xml_node keyword = doc.child("keywords").child("keyword"); keyword; keyword = keyword.next_sibling("keyword"))
    {
		type=keyword.attribute("ruleType").as_int();
		
		if(type==7)
		{
			for (xml_node noun=keyword.child("base").child("nouns").child("noun"); noun; noun = noun.next_sibling("noun"))
			{
			string nounstr=noun.child_value("value");
			for(unsigned int i=0;i<str.size();i++)
			if(str.substr(i,nounstr.size()).compare(nounstr)==0)
				{
					result.noun=nounstr;
					result.ruleNo=7;
					result.isThisBase=true;
					return result;
				}
			}//nouns
			break;
		}
		checkNeuter=false;
		checkVerb=false;
		checkPreposition=false;
		neutersCount=0; 
		verbsCount=0;
		prepositionsCount=0;
		
		for (xml_node neuter=keyword.child("base").child("neuters").child("neuter"); neuter; neuter = neuter.next_sibling("neuter"))
		{
		neutersCount+=1;
		string neuterstr=neuter.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,neuterstr.size()).compare(neuterstr)==0)
			{
				result.neuter=neuterstr;
				checkNeuter=true;
			}
		}//neuters
		if(neutersCount==0)
			checkNeuter=true;//if there are no neuters in xml, do not require them in rules
		for (xml_node verb=keyword.child("base").child("verbs").child("verb"); verb; verb = verb.next_sibling("verb"))
		{
		verbsCount+=1;
		string verbstr=verb.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,verbstr.size()).compare(verbstr)==0)
			{
				result.verb=verbstr;
				checkVerb=true;
			}
		}//verbs
		if(verbsCount==0)
			checkVerb=true;//if there are no verbs in xml, do not require them in rules
		for (xml_node preposition=keyword.child("base").child("prepositions").child("preposition"); preposition; preposition = preposition.next_sibling("preposition"))
		{
		prepositionsCount+=1;
		string prepositionstr=preposition.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,prepositionstr.size()).compare(prepositionstr)==0)
			{
				result.preposition=prepositionstr;
				checkPreposition=true;
			}
		}//prepositions
		if(prepositionsCount==0)
			checkPreposition=true;
		//if there are no neuters in xml, do not require them in rules
    if(checkNeuter && checkVerb && checkPreposition)
		{
			result.ruleNo=type;
				return result;		
		}

	}//base keywords

	//alt keywords
	for (xml_node keyword = doc.child("keywords").child("keyword"); keyword; keyword = keyword.next_sibling("keyword"))
    {
		type=keyword.attribute("ruleType").as_int();
		if(type==7)
			break;
		checkNeuter=false;
		checkVerb=false;
		checkPreposition=false;
		neutersCount=0; 
		verbsCount=0;
		prepositionsCount=0;
		for (xml_node neuter=keyword.child("alt").child("neuters").child("neuter"); neuter; neuter = neuter.next_sibling("neuter"))
		{
		neutersCount+=1;
		string neuterstr=neuter.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,neuterstr.size()).compare(neuterstr)==0)
			{
				result.neuter=neuterstr;
				checkNeuter=true;
			}
		}//neuters
		if(neutersCount==0)
			checkNeuter=true;//if there are no neuters in xml, do not require them in rules
		for (xml_node verb=keyword.child("alt").child("verbs").child("verb"); verb; verb = verb.next_sibling("verb"))
		{
		verbsCount+=1;
		string verbstr=verb.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,verbstr.size()).compare(verbstr)==0)
			{
				result.verb=verbstr;
				checkVerb=true;
			}
		}//verbs
		if(verbsCount==0)
			checkVerb=true;//if there are no verbs in xml, do not require them in rules
		for (xml_node preposition=keyword.child("alt").child("prepositions").child("preposition"); preposition; preposition = preposition.next_sibling("preposition"))
		{
		prepositionsCount+=1;
		string prepositionstr=preposition.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,prepositionstr.size()).compare(prepositionstr)==0)
			{
				result.preposition=prepositionstr;
				checkPreposition=true;
			}
		}//prepositions
		if(prepositionsCount==0)
			checkPreposition=true;
		//if there are no neuters in xml, do not require them in rules
    if(checkNeuter && checkVerb && checkPreposition)
		{
			result.ruleNo=type+10;
			if(result.ruleNo==16)
				result.ruleNo=0;

				return result;			
		}

	}//alt keywords

	result.ruleNo=0;
	return result;
	}//isthisRule


	string getConstraint(string str,int &cstvalue)//return also id of constraint
	{
		xml_document doc;
		xml_parse_result resultxml = doc.load_file("constraints.xml");
		int type=0;
		string constraint;

	for (xml_node cons = doc.child("constraints").child("constraintsGroup"); cons; cons = cons.next_sibling("constraintsGroup"))
    {
		type=cons.attribute("id").as_int();
		for (xml_node con = cons.child("constraint"); con; con = con.next_sibling("constraint"))
		{
		constraint=con.child_value("value");
		for(unsigned int i=0;i<str.size();i++)
		if(str.substr(i,constraint.size()).compare(constraint)==0)
			{
				cstvalue=type;
				return constraint;
			}
		}
	}

	return "";
	}

	void catchRule(string str, ruleSyntax ruleData,int constraintValue)
	{
		string keyword=""+ruleData.neuter;
		string temp="";
		string baseAgent;
		string parentAgent;
		string optionalAgent;
		bool addbase=true,addparent=true,addoptional=true;//variable used to check if there is need to add agent to list.
		agent h;//for iteration
		int andPos=0; //index for position of and for rule 6

		if(ruleData.neuter.size()>0 && ruleData.verb.size()>0)
			keyword+=" ";
		keyword+=ruleData.verb;
		if(ruleData.verb.size()>0 && ruleData.preposition.size()>0)
			keyword+=" ";

		keyword+=ruleData.preposition;
	
		rule r;
		r.setBaseAgent(NULL);
		r.setParentAgent(NULL);
		r.setOptionalAgent(NULL);
		r.setConstraint(NULL);

		if(ruleData.ruleNo==7)
		{
			list <agent*> forRule7;
			int remember=0;

			r.setRuleNo(6);

			for(unsigned int i=0;i<str.size();i++)
			{
				if(str.substr(i,ruleData.noun.size()).compare(ruleData.noun)==0)
					remember+=ruleData.noun.size()+1;
				if(str.substr(i,3).compare("and")==0)
				{
					agent agnt;
					for( list<agent>::iterator iter=this->agents.begin(); iter != this->agents.end(); )
					{
						agnt=*iter;
						if(agnt.getName().compare(str.substr(remember,i-remember-1))==0)
						{
							r.addAgentForRule7(&(*iter));
							this->notificationList+="Agent: "+agnt.getName()+"\n";
							
							break;
						}
						++iter;
					}
					
					remember=i+4;
				}
				if(str.substr(i,2).compare("is")==0)
				{
					agent agnt;
					for( list<agent>::iterator iter=this->agents.begin(); iter != this->agents.end(); )
					{
						agnt=*iter;
						if(agnt.getName().compare(str.substr(remember,i-remember-1))==0)
						{
							r.addAgentForRule7(&(*iter));
							this->notificationList+="Agent: "+agnt.getName()+"\n";
							
							break;
						}
						++iter;
					}
					remember=i+3;
				}
			}
		}//end of scope for rule 7

		else //if it is not rule 7 (different grammar)
		{
		for(unsigned int i=0;i<str.size();i++)
		{
		//for rules 2-5
		if(ruleData.ruleNo<6 || (ruleData.ruleNo>11 && ruleData.ruleNo<16))
		{
		//for rules 2-4
		if(ruleData.ruleNo<5 || (ruleData.ruleNo>11 && ruleData.ruleNo<15))
			if(ruleData.constraint.size()>0)
			{
				if(str.substr(i,ruleData.constraint.size()).compare(ruleData.constraint)==0)
				{
					if(ruleData.ruleNo<5)
						parentAgent=temp.substr(keyword.size(),temp.size()-keyword.size()-1);
					else
						baseAgent=temp.substr(keyword.size(),temp.size()-keyword.size()-1);
				}
			}
			if(ruleData.constraint.size()==0)
			{
				if(i==str.size()-1)
				{
					if(ruleData.ruleNo<5)
						parentAgent=temp.substr(keyword.size(),temp.size()-keyword.size())+str.substr(str.size()-1);
					else
					{
						if(ruleData.ruleNo==5)
							baseAgent=str.substr(0,str.size()-keyword.size());
						if(ruleData.ruleNo==14)
							baseAgent=str.substr(parentAgent.size()+ruleData.verb.size()+ruleData.preposition.size()+3);
						if(ruleData.ruleNo==12 || ruleData.ruleNo==13)
							baseAgent=str.substr(parentAgent.size()+ruleData.verb.size()+2);
					}
				}
			}
		//for rules 2-5
		if(str.substr(i,keyword.size()).compare(keyword)==0)
			{
				if(ruleData.ruleNo<=5 || ruleData.ruleNo==15)
					baseAgent=temp.substr(0,temp.size()-1);
				else
					parentAgent=temp.substr(0,temp.size()-1);
				temp="";
			}
		else
			temp+=str[i];
		}//2-5 loop

		//for rule 6
		if(ruleData.ruleNo == 6 || ruleData.ruleNo == 16)
		{
			if(str.substr(i,3).compare("and")==0)
				andPos=i;
				if(ruleData.constraint.size()>0)
				{
					if(str.substr(i,ruleData.constraint.size()).compare(ruleData.constraint)==0)
					{	
						baseAgent=temp.substr(keyword.size(),temp.size()-keyword.size()-1);		
					}
				}
			if(ruleData.constraint.size()==0)
			{
				if(i==str.size()-1)
				{
						baseAgent=temp.substr(keyword.size(),temp.size()-keyword.size())+str.substr(str.size()-1);	
				}
			}
		if(str.substr(i,keyword.size()).compare(keyword)==0)
			{
				
				parentAgent=temp.substr(0,temp.size()-1);
				temp="";
			}
		else
			temp+=str[i];
		}

		}//end of loop
		
		//additional string operations for rule 6
		if(ruleData.ruleNo == 6 || ruleData.ruleNo == 16)
		{
		optionalAgent=parentAgent.substr(andPos+4);
		parentAgent=parentAgent.substr(0,andPos-1);
		}

		
		if(baseAgent.size()>0 || parentAgent.size()>0 || optionalAgent.size()>0)
		{
		
			for( list<agent>::iterator iter=this->agents.begin(); iter != this->agents.end(); )
			{
				h= *iter;
				if (h.getName().compare(baseAgent)==0)
					{
					addbase=false;
					r.setBaseAgent(&(*iter));
					}
				if (h.getName().compare(parentAgent)==0)
					{
					addparent=false;
					r.setParentAgent(&(*iter));
					}
				if (h.getName().compare(optionalAgent)==0)
					{
					addoptional=false;
					r.setOptionalAgent(&(*iter));
					}
				++iter;
			}

		if(addbase && baseAgent.size()>0)
			{
			agent x;
			x.setName(baseAgent);
			this->agents.push_back(x);
			r.setBaseAgent(&agents.back());
			}
		if(addparent && parentAgent.compare(baseAgent)!=0 && parentAgent.size()>0)
			{
			agent x;
			x.setName(parentAgent);
			this->agents.push_back(x);
			r.setParentAgent(&agents.back());
			}
		else
			if(addparent && parentAgent.size()>0)
				{
				r.setParentAgent(&agents.back());
				}
		if(addoptional && optionalAgent.compare(baseAgent)!=0 && optionalAgent.compare(parentAgent)!=0 && optionalAgent.size()>0)//if there is not already agent named like this
			{
			agent x;
			x.setName(optionalAgent);
			this->agents.push_back(x);			
			r.setOptionalAgent(&agents.back());
			}
			else
			if(addoptional && optionalAgent.compare(parentAgent)==0 && optionalAgent.size()>0) // if there is, but its its previously added
				{
				r.setOptionalAgent(&agents.back());
				}
			else
				if(addoptional && optionalAgent.compare(baseAgent)==0 && optionalAgent.size()>0) // if base and optional agents are same, get pointer to base agent, twice backing
				{
				list <agent>::iterator c1;
				c1=this->agents.end();
				c1--;
				c1--;
				r.setOptionalAgent(&*c1);
				}

		}
		if(ruleData.ruleNo<10)
			r.setRuleNo(ruleData.ruleNo-1);
		else
			r.setRuleNo(ruleData.ruleNo-10-1);
		}//end of rules 2-6

		//set, which const/variable is this and create constraint
		bool afterConstraint=false;
		constValue cc;
		constraint cst;
		variableValue vv;

		for(unsigned int i=0;i<str.size();i++)
		{
			if(str.substr(i,ruleData.constraint.size()).compare(ruleData.constraint)==0)
				afterConstraint=true;
			if(afterConstraint)
			{
			for( list<constValue>::iterator iter=this->constants.begin(); iter != this->constants.end(); )     
			{
				cc=*iter;
				if(str.substr(i,cc.name.size()+1).compare(" "+cc.name)==0)
				{
					cst.constant=true;
					cst.c=(&(*iter));
					cst.type=constraintValue;
					constraints.push_back(cst);
					r.setConstraint(&constraints.back());
					break;
				}
				++iter;
			}//for

			for( list<variableValue>::iterator iter=this->variables.begin(); iter != this->variables.end(); )     
			{
				vv=*iter;
				if(str.substr(i,vv.name.size()+1).compare(" "+vv.name)==0)
				{
					cst.constant=false;
					cst.v=(&(*iter));
					cst.type=constraintValue;
					constraints.push_back(cst);
					r.setConstraint(&constraints.back());
					break;
				}
				++iter;
			}//for

			}
		}
		
			if(ruleData.ruleNo>10)
				this->notificationList+="Matched rule: "+r.getRuleNoS()+"\n";
			else
				this->notificationList+="Matched rule: "+r.getRuleNoS()+"\n";
			if(baseAgent.size()>0)
				this->notificationList+="Agent: "+baseAgent+"\n";
			if(parentAgent.size()>0)
				this->notificationList+="Agent: "+parentAgent+"\n";
			if(optionalAgent.size()>0)
				this->notificationList+="Agent: "+optionalAgent+"\n";
		

		rules.push_back(r);


	}


#pragma endregion

public: 
	
	parser(char *file)
	{
		this->file=file;
		this->errorList="";
		this->notificationList="";
	}

	parser(void)
	{
		this->file=NULL;
		this->errorList="";
		this->notificationList="";
	}

	string errors()
	{
		return this->errorList;
	}

	string notifications()
	{
		return this->notificationList;
	}

#pragma region parse

bool parse() //false if there was errors while parsing.
{

	FILE * pFile;
	int c;
	string mystring[100];
	int stringline=0;
	this->errorList="";
	this->notificationList="";

   pFile = fopen (file , "r");
   if (pFile == NULL) perror ("Error opening file");
   else {
	   do {
      c = fgetc (pFile); //10 - newline, -1 eof
	  if(c==-1)
		  break;
	  if(c==10)
	  {
		  stringline+=1;
		  continue;
	  }
	  mystring[stringline]+=c;

    } while (c != EOF);
     fclose (pFile);
   }

   /////////////////////////////parsing

	ruleSyntax ruleData;
	int constraintValue;
	bool correctLine;
	string tmp; 
	

	for(int l=0;l<=stringline;l++)
	{
		this->notificationList+="Rule:\n";
		this->notificationList+=mystring[l]+"\n";
		
		//next line.
	correctLine=false;
	list <string> expressions;
	string expression="";
	string keyword="";
   
	ruleData=isThisRule2(mystring[l]);
   if(ruleData.ruleNo!=0)
   {
	   ruleData.constraint=getConstraint(mystring[l],constraintValue);
	   catchRule(mystring[l],ruleData,constraintValue);
	   correctLine=true;
   }
   else
	   if(isThisConstOrVariable(mystring[l]))
	   {
		   addValue(mystring[l]);
		   correctLine=true;
	   }
		
	if(!correctLine)
		{
			sprintf((char*)tmp.c_str(), "%d", l+1);
			string strerr = tmp.c_str();
			this->errorList+="Error on line: "+strerr+"\n";
		}
	}//end of rules loop

	//parsing ended.
	

return true;

}//parse
#pragma endregion

#pragma region gets

	list<constValue> getConstants()
	{
		return this->constants;
	}
	list<variableValue> getVariables()
	{
		return this->variables;
	}
	list<agent> getAgents()
	{
		return this->agents;
	}
	list<rule> getRules()
	{
		return this->rules;
	}
	list<constraint> getConstraints()
	{
		return this->constraints;
	}
#pragma endregion

};//class

#pragma endregion


}

using namespace ParserHCV;


int _tmain(int argc, _TCHAR* argv[])
{
	parser x("text.txt");
	x.parse();

	cout<<x.errors();
	cout<<x.notifications();
	return 0;
}